# $Id: fib.s,v 1.2 2003/01/17 14:44:13 jdw108 Exp $
# Fibonacci sequence generator. Outputs the sequence
# to 0x8000 and RAM.

        .global _start


_start:
        .text
        .align 2

        # Initial values.
        moveql  #0,%d0
        moveql  #1,%d1

        # RAM address 0x1004 is used to count the index number.
        # We count backwards for a laugh. (not a very funny one)
        # To make the joke even funnier I use address register 0
        # to hold 0x1004 and do all the subtractions in ARI
        # mode.
        movel   #0x1004,%a0

fib:    # Copy current number to the output
        moveb   %d1,0x8000   
        # and make a copy in RAM
        movel   %d1,0x1000   

        # Get next number. Next = current + last
        movel   %d1,%d2    
        addl    %d0,%d1   
        movel   %d2,%d0  

        subql   #1,(%a0)
    
        # Repeat ad nauseum
        bra     fib



