#ifndef TTYOUTMMDEVICE_HH
#define TTYOUTMMDEVICE_HH

#include <stdio.h>


#include <vm68k/types.h>
#include <vm68k/memory.h>
#include <vm68k/processor.h>

#include "mmdevice.hh"


using namespace vm68k ;



class TTYOutMMDevice : public MMDevice
{
public:
    TTYOutMMDevice ( FILE * output ) ;
    virtual ~TTYOutMMDevice () ;

    void put_8(uint32_type address, int value, function_code fc) ;

private:
    FILE * output ;
} ;


#endif


